;*******************************************************************************
.DEVICE AT90S2313
;*******************************************************************************
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;    RR4NA
;
; V2.00 20.12.2003
;  4
;  D ........................  
; P3.0 - BUSY.................... 1.0 - TX 145 .................
; P3.1 - ........................ P1.1 - MOD TX .................
; P3.2 - ........................ P1.2 - ........................
; P3.3 - ........................ P1.3 - ........................
; P3.4 - ........................ P1.4 - LED TX Red .............
; P3.5 - ........................ P1.5 - LED RX Green............
; P3.6 - ........................ P1.6 - ........................
;................................ P1.7 - Sound...................
; Register:
.def zero =r0
.def SREG =r1
.def odin =r2
.def dz =r25;  7 cek
.def z28 =r28;  1,5  .
.def f29 =r29;    1,5  .
.def dz30 =r30;       .
.def dz31 =r31;       .
.CSEG
;*******************************************************************************
;   AVR AT90S2313-10PI
;*******************************************************************************
START:   wdr
         ldi r20,0xDF         ; 0xDF
         out 0x3D,r20         ;     .
         ldi r20,0x0F
         out 0x21,r20         ;    2,048 .
         rjmp START1
;*******************************************************************************
;   / 0
;
INT:     wdr                  ;  wdr
         in SREG,0x3F         ;    SREG -> SREG
         add dz30,odin
         adc dz31,zero
         add z28,odin
         cpi z28,0x17         ;  1,5 cek (64ms x 24(17h) = 1,5sek).
         brlo INT1
         ser F29              ;     1,5 .
INT1:    out 0x3F,SREG        ; m    SREG -> SREG
         reti                 ;
;*******************************************************************************
START1:  clr zero             ;  R0
         ldi r20,0x01
         mov odin,r20
         out 0x3B,zero        ;    .
         out 0x08,zero        ;  .  .  .
         out 0x11,zero        ;     D
         ldi r20,0xFF         ;  P3.0 - P3.7 -> 
         out 0x12,r20         ;     D
         out 0x17,r20         ;    B P1.0-P1.7 -> 
         out 0x18,zero        ;   
         sbi 0x18,4           ;  LED RX
         sbi 0x18,5           ;  LED TX
         clr dz
         clr dz30
         clr F29
         ser dz31
         dec dz31
         ldi r20,0x80         ;
         out 0x3F,r20         ; SREG  
         ldi r20,0x02         ;
         out 0x39,r20         ; TIMSK   T0
         ldi r20,0x05         ; 0x05=00000101=5   1024
         out 0x33,r20         ;     0
;*******************************************************************************
Main:    cbi 0x18,0           ;   145
         sbi 0x18,5           ;  LED TX
Main1:   wdr
         sbis 0x10,0          ;  BUSY  =1   ( )
         rjmp Main1
         rcall zad50
         sbis 0x10,0          ;  BUSY  =1  
         rjmp Main1
;----  BUSY,  ---
         sbi 0x18,1           ;   
         cbi 0x18,4           ;  LED RX
         sbi 0x18,0           ;   145
         cbi 0x18,5           ;  LED TX
         clr dz
         clr z28              ;   1,5 
         clr f29              ;    1,5 
;----   BUSY---
M1:      wdr
         sbic 0x10,0          ;  BUSY  =0  
         rjmp M1
;----BUSY ---
         cbi 0x18,1           ;   
         sbi 0x18,4           ;  LED RX
;----    1,5   BUSY---
         cpi f29,0x01         ;   f28
         brsh M2
         rjmp main            ; BUSY   1,5 ,   beep
;----   BUSY  beep    7 ---
M2:      inc dz
         wdr
         rcall zad50
         sbic 0x10,0          ;  BUSY  =0  
         rjmp main
         cpi dz,0x0e          ;   
         brne M3
         rcall beep
M3:      cpi dz,0x8C          ;    7 .
         brlo M2
;----     ---
         cpi dz31,24          ;  600  (24h=36 36x16,777=600 cek)
         brlo M4              ;      
         rcall CALL_RR4NA     ;     
M4:      rjmp main
;*******************************************************************************
;            
;*******************************************************************************
;
; CALL+LOC - "RR4NA LO48UO"
;
CALL_RR4NA:
         rcall pausa3
         rcall tocka          ; R
         rcall pausa
         rcall tire
         rcall pausa
         rcall tocka
         rcall pausa3
         rcall tocka          ; R
         rcall pausa
         rcall tire
         rcall pausa
         rcall tocka
         rcall pausa3
         rcall tocka          ; 4
         rcall pausa
         rcall tocka
         rcall pausa
         rcall tocka
         rcall pausa
         rcall tocka
         rcall pausa
         rcall tire
         rcall pausa3
         rcall tire           ;N
         rcall pausa
         rcall tocka
         rcall pausa3
         rcall tocka          ; A
         rcall pausa
         rcall tire
         rcall pausa3
         rcall pausa3
         rcall pausa3
         rcall tocka          ; L
         rcall pausa
         rcall tire
         rcall pausa
         rcall tocka
         rcall pausa
         rcall tocka
         rcall pausa3
         rcall tire           ; O
         rcall pausa
         rcall tire
         rcall pausa
         rcall tire
         rcall pausa3
         rcall tocka          ; 4
         rcall pausa
         rcall tocka
         rcall pausa
         rcall tocka
         rcall pausa
         rcall tocka
         rcall pausa
         rcall tire
         rcall pausa3
         rcall tire          ; 8
         rcall pausa
         rcall tire
         rcall pausa
         rcall tire
         rcall pausa
         rcall tocka
         rcall pausa
         rcall tocka
         rcall pausa3
         rcall tocka          ; U
         rcall pausa
         rcall tocka
         rcall pausa
         rcall tire
         rcall pausa3
         rcall tire           ; O
         rcall pausa
         rcall tire
         rcall pausa
         rcall tire
         rcall pausa3
         rcall pausa3
         rcall pausa3
         clr dz30
         clr dz31
         ret
;*******************************************************************************
;
;   0.05 
;
zad50:
         LDI r19,0x42         ; 
z1:      LDI r21,0xFF
z2:      WDR
         WDR
         WDR
         DEC r21
         BRNE z2              ;  FF .
         LDI r21,0xFA
z3:      WDR
         WDR
         WDR 
         DEC r21
         BRNE z3              ;  FF .
         DEC r19
         BRNE z1              ;  FF .
         RET
;*******************************************************************************
;
;   0.05 
;
pausa:
         LDI r19,0x40         ; 
p1:      LDI r21,0xFF
p2:      WDR
         WDR
         WDR
         DEC r21
         BRNE p2              ;  FF .
         LDI r21,0xFF
p3:      WDR
         WDR
         WDR 
         DEC r21
         BRNE p3              ;  FF .
         DEC r19
         BRNE p1              ;  FF .
         RET
;*******************************************************************************
;
;   0.150 
;
pausa3:  rcall pausa
         rcall pausa
         rcall pausa
         ret
;*******************************************************************************
;
; BEEP  561 Hz  40 mC
;
BEEP:    
         LDI r19,0x14         ;  21
         LDI r22,0xFF
B1:      mov r21,r22
B2:      WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         SBI 0x18,7           ;  Port P3.4  "1"
         DEC r21
         BRNE B2              ;  FF .
         dec r22
         mov r21,r22
B3:      WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         CBI 0x18,7           ;  Port P3.4  "0"
         DEC r21
         BRNE B3              ;  FF .
         dec r22
         DEC r19
         BRNE B1              ;  FF .
         RET
;*******************************************************************************
;
;   CW     712 Hz  67,36 mC
;
tocka:
         LDI r19,0x30         ; 
t1:      LDI r21,0xFF
t2:      WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         SBI 0x18,7           ;  Port P3.4  "1"
         DEC r21
         BRNE t2              ;  FF .
         LDI r21,0xFF
t3:      WDR
         WDR
         WDR
         WDR
         WDR
         WDR
         CBI 0x18,7          ;  Port P3.4  "0"
         DEC r21
         BRNE t3              ;  FF .
         DEC r19
         BRNE t1              ;  FF .
         RET
;*******************************************************************************
;
;   CW    712 Hz  202,08 mC
;
tire:    rcall tocka
         rcall tocka
         rcall tocka
         ret
;*******************************************************************************

